<%@include file="/configuration.jsp"%>
<%@page
  import="org.apache.commons.httpclient.*,org.apache.commons.httpclient.auth.AuthScope,org.apache.commons.httpclient.methods.*,java.io.IOException,java.util.Enumeration,java.util.Map, java.util.HashMap"%>


<%
    final class Connection {

        private Merchant merchant;

        Connection(Merchant merchant) {
            this.merchant = merchant;
        }

        String sendTransaction(PostMethod postMethod) throws Exception {
            HttpClient httpClient = new HttpClient();
            configureProxy(httpClient);
            String body = null;
            // [Snippet] howToSetHeaders - start
            // set the charset to UTF-8
            postMethod.addRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
            // [Snippet] howToSetHeaders - end
            // [Snippet] executeSendTransaction - start
            try {
                // send the transaction
                httpClient.executeMethod(postMethod);
                body = postMethod.getResponseBodyAsString();
            } catch (IOException ioe) {
                // we can replace a specific exception that
                // suits your application
                throw new Exception(ioe);
            } finally {
                postMethod.releaseConnection();
            }
            // [Snippet] executeSendTransaction - end
            return body;
        }


         // [Snippet] howToConfigureProxy - start
         // Check if proxy config is defined, if so configure the host and http client to tunnel through
         void configureProxy(HttpClient httpClient) {
             // If proxy server is defined, set the host configuration.
             if (merchant.getProxyServer() != null) {
                 HostConfiguration hostConfig = httpClient.getHostConfiguration();
                 hostConfig.setHost(merchant.getGatewayHost());
                 hostConfig.setProxy(merchant.getProxyServer(), merchant.getProxyPort());

             }
             // If proxy authentication is defined, set proxy credentials
             if (merchant.getProxyUsername() != null) {
                 NTCredentials proxyCredentials =
                         new NTCredentials(merchant.getProxyUsername(),
                                 merchant.getProxyPassword(), merchant.getGatewayHost(),
                                 merchant.getNtDomain());
                 httpClient.getState().setProxyCredentials(merchant.getProxyAuthType(),
                         merchant.getProxyServer(), proxyCredentials);
             }
         }
         // [Snippet] howToConfigureProxy - end

    }

    final class Parser {

        private Merchant merchant;

        Parser(Merchant merchant) {
            this.merchant = merchant;
        }

        // [Snippet] howToConfigureURL - start
        // Modify gateway URL to set the version
        // Assign it to the gatewayUrl member in the merchantObj object
        String formRequestUrl() {
            StringBuilder builder = new StringBuilder(merchant.getGatewayUrl());
            builder.append("/version/");
            builder.append(merchant.getVersion());
            merchant.setGatewayUrl(builder.toString());
            return merchant.getGatewayUrl();
        }

        // [Snippet] howToConfigureURL - end

        // [Snippet] howToConvertFormData - start
        // Form post request and append merchantId & apiPassword
        PostMethod parse(HttpServletRequest request) {
            Map<String, String> requestFields = new HashMap<String, String>();
            // [Snippet] howToPost - start
            // [Snippet] howToSetURL - start
            PostMethod method = new PostMethod(merchant.getGatewayUrl());
            // [Snippet] howToSetURL - end
            // [Snippet] howToPost - end
            // [Snippet] howToSetCredentials - start
            // For NVP, authentication details are passed in the body as Name-Value-Pairs,
            // just like any other data field
            method.addParameter("merchant", merchant.getMerchantId());
            method.addParameter("apiUsername", merchant.getApiUsername());
            method.addParameter("apiPassword", merchant.getPassword());
            // [Snippet] howToSetCredentials - end
            Enumeration<String> paramNames = request.getParameterNames();
            while (paramNames.hasMoreElements()) {
                String fieldName = paramNames.nextElement();
                String fieldValue = request.getParameter(fieldName);
                if ((fieldValue != null) && (fieldValue.length() > 0)) {
                    requestFields.put(fieldName, fieldValue);
                    method.addParameter(fieldName, fieldValue);
                }
            }

            // API will reject unused parameters, we need to remove them
            method.removeParameter("submit");
            method.removeParameter("version");
            return method;

        }
        // [Snippet] howToConvertFormData - end

    }
%>